#ifndef STARSIDAProgram_h
#define STARSIDAProgram_h

#include <list>
// #include <map>
// #include <set>
// #include <string>

// #include <cstdint>
// #include <cstdio>

// #include <intel.hpp>  // indirectly includes the unguarded allins.hpp header

// #include "interfaces/STARSTypes.h"
#include "interfaces/abstract/STARSProgram.h"

#include "base/SMPProgram.h"

class STARS_IDA_Program_t : public STARS_Program_t {
public:
	// Data initialization
	virtual void InitData(void);
	void DetermineRootFileName(void);
	bool OpenFiles(void);
	void CloseFiles(void);

	// Get (accessor) methods

	// Set (mutator) methods

	// Query methods

	// Printing methods
	virtual void PrintAllCodeToCodeXrefs(STARS_ea_t InstAddr, std::size_t InstSize, bool CallFlag);

	// Analysis methods

	// NOTE: Change this when we do targets with data (other than switch tables) in code.
	//  Call IsDataAddress() first to weed out data items in the code range.
	bool IsImmedCodeAddress(STARS_ea_t ImmedValue) {
		return ((ImmedValue >= LowestCodeAddress) && (ImmedValue <= HighestCodeAddress));
	}
	void ReportTotalCodeSize(unsigned long long TotalCodeSize);
	void InitStaticDataTable(SMPProgram *CurrProg);
	void GetBlockSuccessorTargets(bool CallFlag, STARS_InstructionID_t LastBlockInst, std::size_t InstSize, std::list<STARS_InstructionID_t> &SuccList); // Get successors for LastBlockInst, omitting call targets

private:
	// Data
	std::size_t STARS_Platform_Bitwidth; // not binary, but the system OS we are running on

	// Methods
	void ComputeGlobalFieldOffsets(struct GlobalVar &CurrGlobal);
	
};

#endif
